Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/HeuristicLab.DataPreprocessing.Views-3.4.csproj
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/HeuristicLab.DataPreprocessing.Views-3.4.csproj	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/HeuristicLab.DataPreprocessing.Views-3.4.csproj	(revision 15242)
@@ -89,10 +89,7 @@
   <ItemGroup>
     <Reference Include="System" />
-    <Reference Include="System.Core" />
-    <Reference Include="System.Data" />
     <Reference Include="System.Drawing" />
     <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Windows.Forms.DataVisualization" />
-    <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
@@ -128,4 +125,9 @@
       <DependentUpon>ComparisonFilterView.cs</DependentUpon>
     </Compile>
+    <Compile Include="PreprocessingIcons.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>PreprocessingIcons.resx</DependentUpon>
+    </Compile>
     <Compile Include="RenameColumnsDialog.cs">
       <SubType>Form</SubType>
@@ -159,10 +161,4 @@
     </Compile>
     <Compile Include="DataPreprocessorStarter.cs" />
-    <Compile Include="PreprocessingDataTableView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="PreprocessingDataTableView.Designer.cs">
-      <DependentUpon>PreprocessingDataTableView.cs</DependentUpon>
-    </Compile>
     <Compile Include="FilterView.cs">
       <SubType>UserControl</SubType>
@@ -177,10 +173,4 @@
       <DependentUpon>ScatterPlotMultiView.cs</DependentUpon>
     </Compile>
-    <Compile Include="PreprocessingScatterPlotView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="PreprocessingScatterPlotView.Designer.cs">
-      <DependentUpon>PreprocessingScatterPlotView.cs</DependentUpon>
-    </Compile>
     <Compile Include="SearchAndReplaceDialog.cs">
       <SubType>Form</SubType>
@@ -214,10 +204,4 @@
       <DependentUpon>PreprocessingChartView.cs</DependentUpon>
     </Compile>
-    <Compile Include="PreprocessingCheckedItemListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="PreprocessingCheckedItemListView.Designer.cs">
-      <DependentUpon>PreprocessingCheckedItemListView.cs</DependentUpon>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="StatisticsView.cs">
@@ -235,4 +219,7 @@
     <Compile Include="Utils\FindPreprocessingItemsIterator.cs" />
     <Compile Include="Utils\IFindPreprocessingItemsIterator.cs" />
+    <Compile Include="Utils\VerticalLabel.cs">
+      <SubType>Component</SubType>
+    </Compile>
     <Compile Include="ViewShortcutListView.cs">
       <SubType>UserControl</SubType>
@@ -249,15 +236,15 @@
   <ItemGroup>
     <ProjectReference Include="..\..\HeuristicLab.Analysis.Views\3.3\HeuristicLab.Analysis.Views-3.3.csproj">
-      <Project>{76945d76-ca61-4147-9dc2-0acdcddf87f9}</Project>
+      <Project>{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}</Project>
       <Name>HeuristicLab.Analysis.Views-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
-      <Project>{887425b4-4348-49ed-a457-b7d2c26ddbf9}</Project>
+      <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
       <Name>HeuristicLab.Analysis-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
-      <Project>{958b43bc-cc5c-4fa2-8628-2b3b01d890b6}</Project>
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
       <Name>HeuristicLab.Collections-3.3</Name>
       <Private>False</Private>
@@ -269,15 +256,15 @@
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
-      <Project>{a9ad58b9-3ef9-4cc1-97e5-8d909039ff5c}</Project>
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
       <Name>HeuristicLab.Common-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{e226881d-315f-423d-b419-a766fe0d8685}</Project>
+      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
       <Name>HeuristicLab.Core.Views-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
-      <Project>{c36bd924-a541-4a00-afa8-41701378ddc5}</Project>
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
       <Name>HeuristicLab.Core-3.3</Name>
       <Private>False</Private>
@@ -289,10 +276,10 @@
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.DataPreprocessing\3.4\HeuristicLab.DataPreprocessing-3.4.csproj">
-      <Project>{3b90f866-70f8-43ef-a541-51819d255b7b}</Project>
+      <Project>{3B90F866-70F8-43EF-A541-51819D255B7B}</Project>
       <Name>HeuristicLab.DataPreprocessing-3.4</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
-      <Project>{bbab9df5-5ef3-4ba8-ade9-b36e82114937}</Project>
+      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
       <Name>HeuristicLab.Data-3.3</Name>
       <Private>False</Private>
@@ -304,10 +291,10 @@
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
-      <Project>{3bd61258-31da-4b09-89c0-4f71fef5f05a}</Project>
+      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
       <Name>HeuristicLab.MainForm-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
-      <Project>{14ab8d24-25bc-400c-a846-4627aa945192}</Project>
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
       <Name>HeuristicLab.Optimization-3.3</Name>
       <Private>False</Private>
@@ -319,15 +306,15 @@
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
-      <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj">
-      <Project>{3e9e8944-44ff-40bb-a622-3a4a7dd0f198}</Project>
+      <Project>{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}</Project>
       <Name>HeuristicLab.Problems.DataAnalysis.Views-3.4</Name>
       <Private>False</Private>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
-      <Project>{df87c13e-a889-46ff-8153-66dcaa8c5674}</Project>
+      <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
       <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
       <Private>False</Private>
@@ -353,4 +340,18 @@
       <Private>False</Private>
     </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="PreprocessingIcons.resx">
+      <Generator>ResXFileCodeGenerator</Generator>
+      <LastGenOutput>PreprocessingIcons.Designer.cs</LastGenOutput>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ScatterPlotSingleView.resx">
+      <DependentUpon>ScatterPlotSingleView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Icons\All.png" />
+    <Content Include="Icons\Inputs.png" />
+    <Content Include="Icons\None.png" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 15242)
@@ -45,14 +45,25 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.optionsBox = new System.Windows.Forms.GroupBox();
-      this.displayDetailsCheckBox = new System.Windows.Forms.CheckBox();
-      this.label1 = new System.Windows.Forms.Label();
-      this.classifierComboBox = new System.Windows.Forms.ComboBox();
+      this.groupingTableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();
+      this.variableLabel = new System.Windows.Forms.Label();
+      this.orderLabel = new System.Windows.Forms.Label();
+      this.aggregationLabel = new System.Windows.Forms.Label();
+      this.orderComboBox = new System.Windows.Forms.ComboBox();
+      this.groupingComboBox = new System.Windows.Forms.ComboBox();
+      this.aggregationComboBox = new System.Windows.Forms.ComboBox();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
       this.splitContainer.SuspendLayout();
       this.optionsBox.SuspendLayout();
+      this.groupingTableLayoutPanel.SuspendLayout();
       this.SuspendLayout();
       // 
+      // sizeGroupBox
+      // 
+      this.sizeGroupBox.Location = new System.Drawing.Point(0, 258);
+      // 
       // splitContainer
       // 
@@ -64,49 +75,101 @@
       // optionsBox
       // 
-      this.optionsBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.optionsBox.Controls.Add(this.displayDetailsCheckBox);
-      this.optionsBox.Controls.Add(this.label1);
-      this.optionsBox.Controls.Add(this.classifierComboBox);
-      this.optionsBox.Location = new System.Drawing.Point(4, 262);
+      this.optionsBox.Controls.Add(this.groupingTableLayoutPanel);
+      this.optionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
+      this.optionsBox.Location = new System.Drawing.Point(0, 302);
       this.optionsBox.Name = "optionsBox";
-      this.optionsBox.Size = new System.Drawing.Size(84, 138);
+      this.optionsBox.Size = new System.Drawing.Size(180, 101);
       this.optionsBox.TabIndex = 7;
       this.optionsBox.TabStop = false;
-      this.optionsBox.Text = "Options";
-      // 
-      // displayDetailsCheckBox
-      // 
-      this.displayDetailsCheckBox.AutoSize = true;
-      this.displayDetailsCheckBox.Location = new System.Drawing.Point(5, 58);
-      this.displayDetailsCheckBox.Margin = new System.Windows.Forms.Padding(2);
-      this.displayDetailsCheckBox.Name = "displayDetailsCheckBox";
-      this.displayDetailsCheckBox.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
-      this.displayDetailsCheckBox.Size = new System.Drawing.Size(119, 17);
-      this.displayDetailsCheckBox.TabIndex = 3;
-      this.displayDetailsCheckBox.Text = "Display value count";
-      this.displayDetailsCheckBox.UseVisualStyleBackColor = true;
-      this.displayDetailsCheckBox.CheckedChanged += new System.EventHandler(this.displayDetailsCheckBox_CheckedChanged);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 15);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(81, 13);
-      this.label1.TabIndex = 2;
-      this.label1.Text = "Target variable:";
-      // 
-      // classifierComboBox
-      // 
-      this.classifierComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.classifierComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.classifierComboBox.FormattingEnabled = true;
-      this.classifierComboBox.Location = new System.Drawing.Point(5, 32);
-      this.classifierComboBox.Name = "classifierComboBox";
-      this.classifierComboBox.Size = new System.Drawing.Size(73, 21);
-      this.classifierComboBox.TabIndex = 1;
-      this.classifierComboBox.SelectedIndexChanged += new System.EventHandler(this.classifierComboBox_SelectedIndexChanged);
+      this.optionsBox.Text = "Grouping Options";
+      // 
+      // groupingTableLayoutPanel
+      // 
+      this.groupingTableLayoutPanel.ColumnCount = 2;
+      this.groupingTableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
+      this.groupingTableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.groupingTableLayoutPanel.Controls.Add(this.variableLabel, 0, 0);
+      this.groupingTableLayoutPanel.Controls.Add(this.orderLabel, 0, 2);
+      this.groupingTableLayoutPanel.Controls.Add(this.aggregationLabel, 0, 1);
+      this.groupingTableLayoutPanel.Controls.Add(this.orderComboBox, 1, 2);
+      this.groupingTableLayoutPanel.Controls.Add(this.groupingComboBox, 1, 0);
+      this.groupingTableLayoutPanel.Controls.Add(this.aggregationComboBox, 1, 1);
+      this.groupingTableLayoutPanel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupingTableLayoutPanel.Location = new System.Drawing.Point(3, 16);
+      this.groupingTableLayoutPanel.Name = "groupingTableLayoutPanel";
+      this.groupingTableLayoutPanel.RowCount = 3;
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.Size = new System.Drawing.Size(174, 82);
+      this.groupingTableLayoutPanel.TabIndex = 3;
+      // 
+      // variableLabel
+      // 
+      this.variableLabel.AutoSize = true;
+      this.variableLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.variableLabel.Location = new System.Drawing.Point(3, 0);
+      this.variableLabel.Name = "variableLabel";
+      this.variableLabel.Size = new System.Drawing.Size(48, 27);
+      this.variableLabel.TabIndex = 2;
+      this.variableLabel.Text = "Variable:";
+      this.variableLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      // 
+      // orderLabel
+      // 
+      this.orderLabel.AutoSize = true;
+      this.orderLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.orderLabel.Location = new System.Drawing.Point(3, 54);
+      this.orderLabel.Name = "orderLabel";
+      this.orderLabel.Size = new System.Drawing.Size(48, 28);
+      this.orderLabel.TabIndex = 2;
+      this.orderLabel.Text = "Order:";
+      this.orderLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.toolTip.SetToolTip(this.orderLabel, "Order of Legend Entries");
+      // 
+      // aggregationLabel
+      // 
+      this.aggregationLabel.AutoSize = true;
+      this.aggregationLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.aggregationLabel.Location = new System.Drawing.Point(3, 27);
+      this.aggregationLabel.Name = "aggregationLabel";
+      this.aggregationLabel.Size = new System.Drawing.Size(48, 27);
+      this.aggregationLabel.TabIndex = 2;
+      this.aggregationLabel.Text = "Aggr.:";
+      this.aggregationLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.toolTip.SetToolTip(this.aggregationLabel, "Aggregation");
+      // 
+      // orderComboBox
+      // 
+      this.orderComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.orderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.orderComboBox.FormattingEnabled = true;
+      this.orderComboBox.Location = new System.Drawing.Point(57, 57);
+      this.orderComboBox.Name = "orderComboBox";
+      this.orderComboBox.Size = new System.Drawing.Size(114, 21);
+      this.orderComboBox.TabIndex = 1;
+      this.orderComboBox.SelectedIndexChanged += new System.EventHandler(this.orderComboBox_SelectedIndexChanged);
+      // 
+      // groupingComboBox
+      // 
+      this.groupingComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupingComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.groupingComboBox.FormattingEnabled = true;
+      this.groupingComboBox.Location = new System.Drawing.Point(57, 3);
+      this.groupingComboBox.Name = "groupingComboBox";
+      this.groupingComboBox.Size = new System.Drawing.Size(114, 21);
+      this.groupingComboBox.TabIndex = 1;
+      this.groupingComboBox.SelectedIndexChanged += new System.EventHandler(this.classifierComboBox_SelectedIndexChanged);
+      // 
+      // aggregationComboBox
+      // 
+      this.aggregationComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.aggregationComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.aggregationComboBox.FormattingEnabled = true;
+      this.aggregationComboBox.Location = new System.Drawing.Point(57, 30);
+      this.aggregationComboBox.Name = "aggregationComboBox";
+      this.aggregationComboBox.Size = new System.Drawing.Size(114, 21);
+      this.aggregationComboBox.TabIndex = 1;
+      this.aggregationComboBox.SelectedIndexChanged += new System.EventHandler(this.aggregationComboBox_SelectedIndexChanged);
       // 
       // HistogramView
@@ -120,5 +183,6 @@
       this.splitContainer.ResumeLayout(false);
       this.optionsBox.ResumeLayout(false);
-      this.optionsBox.PerformLayout();
+      this.groupingTableLayoutPanel.ResumeLayout(false);
+      this.groupingTableLayoutPanel.PerformLayout();
       this.ResumeLayout(false);
 
@@ -128,8 +192,12 @@
 
     private System.Windows.Forms.GroupBox optionsBox;
-    private System.Windows.Forms.ComboBox classifierComboBox;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.CheckBox displayDetailsCheckBox;
-
+    private System.Windows.Forms.ComboBox groupingComboBox;
+    private System.Windows.Forms.Label variableLabel;
+    private System.Windows.Forms.Label aggregationLabel;
+    private System.Windows.Forms.ComboBox aggregationComboBox;
+    private System.Windows.Forms.TableLayoutPanel groupingTableLayoutPanel;
+    private System.Windows.Forms.Label orderLabel;
+    private System.Windows.Forms.ComboBox orderComboBox;
+    private System.Windows.Forms.ToolTip toolTip;
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 15242)
@@ -21,36 +21,12 @@
 
 using System;
+using System.Drawing;
 using HeuristicLab.Analysis;
 using HeuristicLab.MainForm;
 
 namespace HeuristicLab.DataPreprocessing.Views {
-
   [View("Histogram View")]
   [Content(typeof(HistogramContent), true)]
   public partial class HistogramView : PreprocessingChartView {
-    private const string HISTOGRAM_CHART_TITLE = "Histogram";
-
-    public HistogramView() {
-      InitializeComponent();
-      chartType = DataRowVisualProperties.DataRowChartType.Histogram;
-      chartTitle = HISTOGRAM_CHART_TITLE;
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content != null) {
-        classifierComboBox.Items.Clear();
-        classifierComboBox.Items.Add("None");
-
-        foreach (string var in Content.GetVariableNamesForHistogramClassification()) {
-          classifierComboBox.Items.Add(var);
-        }
-
-        if (classifierComboBox.SelectedItem == null && Content.ClassifierVariableIndex < classifierComboBox.Items.Count) {
-          classifierComboBox.SelectedIndex = Content.ClassifierVariableIndex;
-        }
-      }
-    }
-
     public new HistogramContent Content {
       get { return (HistogramContent)base.Content; }
@@ -58,29 +34,55 @@
     }
 
-    private void classifierComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      if (classifierComboBox.SelectedItem == null)
-        return;
+    public HistogramView() {
+      InitializeComponent();
+      aggregationComboBox.DataSource = Enum.GetValues(typeof(DataTableVisualProperties.DataTableHistogramAggregation));
+      aggregationComboBox.SelectedItem = DataTableVisualProperties.DataTableHistogramAggregation.Overlapping;
+      orderComboBox.DataSource = Enum.GetValues(typeof(PreprocessingChartContent.LegendOrder));
+      orderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Alphabetically;
+    }
 
-      if (classifierComboBox.SelectedIndex != 0) {
-        int columndIndex = Content.PreprocessingData.GetColumnIndex(classifierComboBox.SelectedItem.ToString());
-        Classification = Content.PreprocessingData.GetValues<double>(columndIndex);
-      } else {
-        Classification = null;
-      }
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      groupingComboBox.Items.Clear();
+      groupingComboBox.Items.Add(string.Empty);
 
-      Content.ClassifierVariableIndex = classifierComboBox.SelectedIndex;
-      if (Content.IsDetailedChartViewEnabled != IsDetailedChartViewEnabled) {
-        displayDetailsCheckBox.Checked = Content.IsDetailedChartViewEnabled;
-      } else {
-        GenerateChart();
+      if (Content != null) {
+        foreach (string var in PreprocessingChartContent.GetVariableNamesForGrouping(Content.PreprocessingData)) {
+          groupingComboBox.Items.Add(var);
+        }
+
+        groupingComboBox.SelectedItem = Content.GroupingVariableName ?? string.Empty;
       }
     }
-    private void displayDetailsCheckBox_CheckedChanged(object sender, EventArgs e) {
-      bool isChecked = displayDetailsCheckBox.Checked;
-      if (IsDetailedChartViewEnabled != isChecked) {
-        IsDetailedChartViewEnabled = isChecked;
-        Content.IsDetailedChartViewEnabled = isChecked;
-        GenerateChart();
+
+    protected override DataTable CreateDataTable(string variableName) {
+      var aggregation = (DataTableVisualProperties.DataTableHistogramAggregation)aggregationComboBox.SelectedItem;
+      var hist = HistogramContent.CreateHistogram(Content.PreprocessingData, variableName, Content.GroupingVariableName, aggregation, Content.Order);
+      hist.VisualProperties.TitleFont = new Font(DefaultFont.FontFamily, 10, FontStyle.Bold);
+      return hist;
+    }
+
+    private void classifierComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      Content.GroupingVariableName = groupingComboBox.SelectedItem.ToString();
+
+      // rebuild datatables
+      InitData();
+      GenerateLayout();
+    }
+
+    private void aggregationComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      foreach (var dt in dataTables.Values) {
+        dt.VisualProperties.HistogramAggregation = (DataTableVisualProperties.DataTableHistogramAggregation)aggregationComboBox.SelectedItem;
       }
+    }
+
+    private void orderComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (Content == null) return;
+
+      Content.Order = (PreprocessingChartContent.LegendOrder)orderComboBox.SelectedItem;
+
+      // rebuild datatables
+      InitData();
+      GenerateLayout();
     }
   }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.Designer.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.Designer.cs	(revision 15242)
@@ -62,10 +62,9 @@
       // optionsBox
       // 
-      this.optionsBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.optionsBox.Controls.Add(this.allInOneCheckBox);
-      this.optionsBox.Location = new System.Drawing.Point(4, 262);
+      this.optionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
+      this.optionsBox.Location = new System.Drawing.Point(0, 357);
       this.optionsBox.Name = "optionsBox";
-      this.optionsBox.Size = new System.Drawing.Size(84, 138);
+      this.optionsBox.Size = new System.Drawing.Size(180, 46);
       this.optionsBox.TabIndex = 7;
       this.optionsBox.TabStop = false;
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 15242)
@@ -21,20 +21,20 @@
 
 using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Analysis;
+using HeuristicLab.Analysis.Views;
+using HeuristicLab.Collections;
+using HeuristicLab.Data;
 using HeuristicLab.MainForm;
+using HeuristicLab.Visualization.ChartControlsExtensions;
 
 namespace HeuristicLab.DataPreprocessing.Views {
-
   [View("Line Chart View")]
   [Content(typeof(LineChartContent), true)]
   public partial class LineChartView : PreprocessingChartView {
-
-    private const string LINE_CHART_TITLE = "Line Chart";
-
-    public LineChartView() {
-      InitializeComponent();
-      chartType = DataRowVisualProperties.DataRowChartType.Line;
-      chartTitle = LINE_CHART_TITLE;
-    }
+    protected Dictionary<string, DataRow> allInOneDataRows;
+    protected DataTable allInOneDataTable;
+    protected DataTableView allInOneDataTableView;
 
     public new LineChartContent Content {
@@ -43,8 +43,63 @@
     }
 
+    public LineChartView() {
+      InitializeComponent();
+      sizeGroupBox.Visible = false;
+
+      allInOneDataRows = new Dictionary<string, DataRow>();
+      allInOneDataTable = new DataTable();
+    }
+
+    protected override void InitData() {
+      base.InitData();
+
+      allInOneDataRows.Clear();
+      foreach (var x in Content.VariableItemList.Select((v, i) => new { variable = v.Value, i })) {
+        var row = Content.CreateDataRow(x.variable, DataRowVisualProperties.DataRowChartType.Line);
+        row.VisualProperties.Color = Colors[x.i % Colors.Length];
+        allInOneDataRows.Add(x.variable, row);
+      }
+
+      allInOneDataTable.Rows.Clear();
+      var rows = Content.VariableItemList.CheckedItems.Select(v => allInOneDataRows[v.Value.Value]);
+      allInOneDataTable.Rows.AddRange(rows);
+    }
+
+    protected override int GetNumberOfVisibleDataTables() {
+      return Content.AllInOneMode ? 1 : base.GetNumberOfVisibleDataTables();
+    }
+    protected override IEnumerable<DataTableView> GetVisibleDataTables() {
+      if (Content.AllInOneMode) {
+        if (allInOneDataTableView == null)
+          allInOneDataTableView = new DataTableView() { Content = allInOneDataTable, ShowChartOnly = true };
+        return new[] { allInOneDataTableView };
+      }
+      return base.GetVisibleDataTables();
+    }
+    protected override DataTable CreateDataTable(string variableName) {
+      var dt = new DataTable();
+      var row = Content.CreateDataRow(variableName, DataRowVisualProperties.DataRowChartType.Line);
+      dt.Rows.Add(row);
+
+      var validValues = row.Values.Where(x => !double.IsNaN(x) && !double.IsInfinity(x)).ToList();
+      if (validValues.Any()) {
+        try {
+          double axisMin, axisMax, axisInterval;
+          ChartUtil.CalculateOptimalAxisInterval(validValues.Min(), validValues.Max(), out axisMin, out axisMax, out axisInterval);
+          dt.VisualProperties.YAxisMinimumAuto = false;
+          dt.VisualProperties.YAxisMaximumAuto = false;
+          dt.VisualProperties.YAxisMinimumFixedValue = axisMin;
+          dt.VisualProperties.YAxisMaximumFixedValue = axisMax;
+        } catch (ArgumentOutOfRangeException) { }
+      }
+      return dt;
+    }
+
     private void allInOneCheckBox_CheckedChanged(object sender, EventArgs e) {
       Content.AllInOneMode = allInOneCheckBox.Checked;
 
-      GenerateChart();
+      sizeGroupBox.Visible = !allInOneCheckBox.Checked;
+
+      GenerateLayout();
     }
 
@@ -55,4 +110,42 @@
       }
     }
+
+    protected override void CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<StringValue>> checkedItems) {
+      base.CheckedItemsChanged(sender, checkedItems);
+
+      foreach (IndexedItem<StringValue> item in checkedItems.Items) {
+        string variableName = item.Value.Value;
+
+        if (IsVariableChecked(variableName)) {
+          // ToDo: avoid clearing all rows, but how?
+          allInOneDataTable.Rows.Clear();
+          var rows = Content.VariableItemList.CheckedItems.Select(r => allInOneDataRows[r.Value.Value]);
+          allInOneDataTable.Rows.AddRange(rows);
+        } else {
+          allInOneDataTable.Rows.Remove(variableName);
+        }
+      }
+    }
+
+    #region Add/Remove/Update Variable, Reset
+    protected override void AddVariable(string name) {
+      base.AddVariable(name);
+      var row = Content.CreateDataRow(name, DataRowVisualProperties.DataRowChartType.Line);
+      allInOneDataTable.Rows.Add(row);
+    }
+
+    // remove variable from data table and item list
+    protected override void RemoveVariable(string name) {
+      base.RemoveVariable(name);
+      allInOneDataTable.Rows.Remove(name);
+    }
+
+    protected override void UpdateVariable(string name) {
+      base.UpdateVariable(name);
+      allInOneDataTable.Rows.Remove(name);
+      var newRow = Content.CreateDataRow(name, DataRowVisualProperties.DataRowChartType.Line);
+      allInOneDataTable.Rows.Add(newRow);
+    }
+    #endregion
   }
 }
